#include "usart.h"
#include "device.h"
#include "spi2.h"
#include "ult.h"
#include "socket.h"
#include "w5500.h"
#include "24c16.h"
#include "md5.h"
#include <string.h>

extern uint8 txsize[];										// ⲿSocketͻС
extern uint8 rxsize[];										// ⲿSocketջС

uint8 buffer[2048];												// һ2KB飬Socketͨ

int main()
{
  uint8 remote_ip[4];			// ԶIPַ
	uint16 remote_port;								// Զ̶˿
  uint16 local_port=4000;									// ʼһض˿
  uint16 len=0;

	
	uint8 DIP[4]={224,1,1,1};
  uint8 DHAR[6]={0x01,0x00,0x5e,0x01,0x01,0x01};
	uint16 DPORT=4000;
  /***** MCUʱӳʼ *****/							  
	Systick_Init(72);	
	
	/***** GPIOSPIʼ *****/
	GPIO_Configuration();			
	WIZ_SPI_Init();
	
	/***** ڳʼ *****/
	USART1_Init(); 		
	
	/***** ʼeeprom *****/
  at24c16_init();
	
	/***** ӲW5500 *****/
	Reset_W5500();
	
	/***** W5500IPϢʼ *****/
	set_default(); 														// ĬMACIPGWSUBDNS
	set_network();														// óʼIPϢӡʼ8Socket

  printf("UDP Local Port: %d \r\n",local_port); 
	printf("UDP Remote IP: %d.%d.%d.%d \r\n",DIP[0],DIP[1],DIP[2],DIP[3]);
  printf("UDP Remote Port: %d \r\n",DPORT);
	printf("W5500 Init Complete!\r\n");
  printf("Start Test!\r\n"); 	

	/*Socket״̬MCUͨSn_SR(0)ֵжSocketӦôں״̬
		Sn_SR״̬
		0x00		SOCK_CLOSED
		0x13		SOCK_INIT
		0x14		SOCK_LISTEN
		0x17		SOCK_ESTABLISHED
		0x1C		SOCK_CLOSE_WAIT
		0x22		SOCK_UDP
	*/
	while(1)																												// Socket״̬
	{
		switch(getSn_SR(0))																						// ȡsocket0״̬
		{
			case SOCK_UDP:																							// Socketڳʼ()״̬
					Delay_ms(100);
					if(getSn_IR(0) & Sn_IR_RECV)
					{
						setSn_IR(0, Sn_IR_RECV);															// Sn_IRRECVλ1
					}
					// ݻػԳݴԶλW5500W5500յݺٻظԶλ
					if((len=getSn_RX_RSR(0))>0)
					{ 
					
						
						recvfrom(0,buffer, len, remote_ip,&remote_port);			// W5500ԶλݣͨSPI͸MCU
						printf("%d.%d.%d.%d:%d\r\n", remote_ip[0],remote_ip[1],remote_ip[2],remote_ip[3],remote_port);
             printf("%s", buffer);														// ڴӡյ
						sendto(0,buffer,len, DIP, DPORT);		  		// յݺٻظԶλݻػ
					}
			break;
			case SOCK_CLOSED:																						// Socketڹر״̬
					 setDIPR(0,DIP);
           setDHAR(0,DHAR);
           setDPORT(0,DPORT);
           socket(0,0x82,4000,0);                      /*ʼsocket 0׽*/									
			break;
		}
	}
}
